iEngine <- function(sumFns) {
#
# Calculate the test statistic in the "interaction" case.`
#
A      <- attr(sumFns,"A")
B      <- attr(sumFns,"B")
AB     <- attr(sumFns,"AB")
Khat   <- wtdMean(sumFns)
Khati  <- lapply(split(sumFns,f=A),wtdMean)
Khatj  <- lapply(split(sumFns,f=B),wtdMean)
Khatij <- lapply(split(sumFns,f=AB),wtdMean)
s2ij   <- estSigsq(sumFns)
M      <- buildM(Khat,Khati,Khatj,Khatij)
wts    <- getWts(sumFns)
a      <- length(levels(A))
b      <- length(levels(B))
mw     <- matrix(sapply(split(wts,f=AB),sum),nrow=a,ncol=b)
tee    <- teeZed(mw,s2ij,witch="tee")
zed    <- teeZed(mw,s2ij,witch="zed")
stilda <- apply(do.call(cbind,s2ij),1,sum)/sum(wts)
V      <- buildV(s2ij,mw,tee,zed,stilda)
MoV    <- M/V
r      <- attr(sumFns,"r")
ens    <- table(A,B)
sum(ens*apply(MoV,c(1,2),trapint,r=r))
}
