tEngine <- function(sumFns) {
#
# Calculate the test statistic in the "twoway`" case.`
#
# Form the relevant means.
#
A     <- attr(sumFns,"A")
a     <- length(levels(A))
xi    <- split(sumFns,f=A)
barxi <- lapply(xi,wtdMean)
barx  <- wtdMean(sumFns)

# Form the test statistic numerators.
M <- (do.call(cbind,barxi) - barx)^2

# Form the variance estimates.
s2j <- estSigsq(sumFns)

# Form "tee".
wtm    <- matrix(sapply(split(getWts(sumFns),f=attr(sumFns,"AB")),sum),nrow=a)
tee    <- teeZed(wtm,s2j,witch="tee")
teemat <- do.call(cbind,tee)
wtv    <- apply(wtm,1,sum)/sum(wtm)
teebar <- teemat%*%wtv

# Form the test statistic denominators.
V <- vector("list",a)
for(i in 1:a) {
    V[[i]] <- tee[[i]]*(1/sum(wtm[i,]) - 2/sum(wtm)) + teebar/sum(wtm)
}
VM   <- do.call(cbind,V)
MoV  <- M/VM
r    <- attr(sumFns,"r")
ens  <- table(A)
sum(ens*apply(MoV,2,trapint,r=r))
}
